#include <stdio.h>
#include <stdbool.h>
int main()
{
    char str[3000];
    scanf("%s",str);
    int d,i,j,maxD;
for ( d = 1; d < sizeof(str); d++) 
{
bool prefiks_suffix = true;
    for ( i = 0, j = sizeof(str) - d; i < d; i++, j++)
    {
    	
        if (str[i] != str[j]) 
        {
            prefiks_suffix = false;
            break;
        }
        if (prefiks_suffix)
		{
			int maxD = d;   
		}   
	}
} 
printf("%d",maxD-1);
return 0;
}